using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
namespace XDGHierRowNumebring.ViewModels
{
    public class ViewModel
    {
        public ObservableCollection<GridData> Data { get; set; }

      

        public ViewModel()
        {
            CreateData();
            
        }

        private string[] names = { "John", "Kim", "Sandy", "Mark", "Josh", "Jim", "Sam", "Mary", 
                                     "Harry", "Sue", "Chris", "Joe", "Carl" };
        private string[] recDescs = { "Test", "Duplicate", "Standard", "Trial", "Expired", "New", "History" };
        private void CreateData()
        {
            Random r = new Random();
            Data = new ObservableCollection<GridData>();
            for (int i = 0; i < 100; i++)
            {
                GridData gd = new GridData()
                {
                    ID = i,
                    Name = names[r.Next(13)],
                    RecDesc = recDescs[r.Next(7)],
                    RecDate = DateTime.Today.AddDays(r.Next(10)),
                    Children = new ObservableCollection<GridData>()
                };
                int childCnt = r.Next(9);
                for (int j = 0; j < childCnt; j++)
                {
                    GridData gd2 = new GridData()
                    {
                        ID = i,
                        Name = names[r.Next(13)],
                        RecDesc = recDescs[r.Next(7)],
                        RecDate = DateTime.Today.AddDays(r.Next(10)),
                        Children = new ObservableCollection<GridData>()
                    };
                    int childCnt2 = r.Next(9);
                    for (int k = 0; k < childCnt2; k++)
                    {
                        gd2.Children.Add(new GridData()
                        {
                            ID = i,
                            Name = names[r.Next(13)],
                            RecDesc = recDescs[r.Next(7)],
                            RecDate = DateTime.Today.AddDays(r.Next(10))
                        });
                    }
                    gd.Children.Add(gd2);
                }
                Data.Add(gd);
            }

            
        }

    }
    public class GridData : INotifyPropertyChanged
    {

        private int id;
        private string name;
        private DateTime recDt;
        private string rec_desc;
        public ObservableCollection<GridData> Children { get; set; }

        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }

        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public string RecDesc
        {
            get { return rec_desc; }
            set
            {
                if (rec_desc != value)
                {
                    rec_desc = value;
                    OnPropertyChanged("RecDesc");
                }
            }
        }

        public DateTime RecDate
        {
            get { return recDt; }
            set
            {
                if (recDt != value)
                {
                    recDt = value;
                    OnPropertyChanged("RecDate");
                }
            }
        }



        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}